#donotrun
#include "3D-1b.frag"
//#include "3DKn-1.1.frag"


#group Raytracer
uniform float Detail; slider[-7,-2.3,0];
uniform float FudgeFactor;slider[0,1,1];
float minDist = pow(10.0,Detail);
uniform int RaySteps;slider[0,56,4000]
vec4 orbitTrap = vec4(10000.0);
uniform int RayDepth;slider[0,2,15]
uniform float MaxDepth;slider[1,15,200]

#group Coloring
uniform float OrbitStrength;slider[0,0,1]
uniform vec4 X;color[-1,0.7,1,0.5,0.6,0.6];
uniform vec4 Y;color[-1,0.4,1,1.0,0.6,0.0];
uniform vec4 Z;color[-1,0.5,1,0.8,0.78,1.0];
uniform vec4 R;color[-1,0.12,1,0.4,0.7,1.0];
uniform bool CycleColors;checkbox[false]
uniform float Cycles;slider[0.1,1.1,32.3]

#group Env
uniform bool BiasedSampling;checkbox[true]
uniform bool DirectLight;checkbox[true]
uniform float SoftShadows;slider[0.00001,0.00001,1.0]
uniform vec4 BgColor; color[0.0,1.,10.0,.3,.5,.7];
uniform vec4 GradientBg; color[0.0,1.,10.0,.3,.5,.7];
uniform bool GradientVignet; checkbox[false]
uniform bool GradientLinear; checkbox[false]
uniform vec3 GradientLinearRot; slider[(-180,-180,-180),(0,0,0),(180,180,180)]
uniform float GradientOffset;slider[-1.5,0.0,1.5]
//uniform float Fog;slider[0.0,0.0,1.5]
uniform vec4 Fog; color[0.0,0.0,1.5,.3,.5,.7];
uniform float Fog_Exp;slider[0.00001,.25,2.0]


#group Material
uniform vec3 Mat_Color;color[1.0,1.0,1.0];
uniform float Mat_Refl;slider[0.0,0.0,1.0]
uniform float Mat_ReflExp;slider[0.00001,.75,1.0]
uniform bool Stratify;checkbox[false]
uniform float Albedo;slider[0,1,1]

#ifdef USE_TEXTURE
#group Texture
uniform int MapType; slider[1,1,3]
uniform sampler2D tex1; file[tex.jpg]
uniform float tex1size; slider[0.0,1.0,20.0]
uniform vec2 tex1offset; slider[(-1,-1),(0,0),(1,1)]
uniform int tex1RepeatMode; slider[0,0,2]
uniform float tex1int; slider[0,1,2]
uniform sampler2D tex2; file[tex.jpg]
uniform float tex2size; slider[0.0,1.0,20.0]
uniform vec2 tex2_offset; slider[(-1,-1),(0,0),(1,1)]
uniform int tex2RepeatMode; slider[0,0,2]
uniform float tex2int; slider[0,1,2]
uniform float tex_normal; slider[0,.5,1]
#endif

#group Floor
uniform bool EnableFloor; checkbox[false] 
uniform vec3 FloorNormal; slider[(-1,-1,-1),(0,0,1),(1,1,1)]
uniform float FloorHeight; slider[-5,0,5]
uniform vec3 FloorColor; color[1,1,1]

mat3 skyrot;
//--------------
//Sunsky.frag
#group Sky
uniform bool EnableSky;checkbox[false]
uniform float turbidity; slider[1,2,16]
// Angular sun size - physical sun is 0.53 degrees
uniform float sunSize; slider[0.476,1,10]
uniform vec2 SunPos; slider[(0,0),(0,0.2),(1,1)]
uniform float SkyFactor; slider[0,1,100]
//uniform vec3 SkyRot; slider[(-180,-180,-180),(0,0,0),(180,180,180)]
uniform float Sunset; slider[0.0,0.0,1.0]

const float mieCoefficient = 0.005;
const float mieDirectionalG = 0.80;
// constants for atmospheric scattering
const float e = 2.71828182845904523536028747135266249775724709369995957;
const float pi = 3.141592653589793238462643383279502884197169;
const float n = 1.0003; // refractive index of air
const float N = 2.545E25; // number of molecules per unit volume for air at
// 288.15K and 1013mb (sea level -45 celsius)
// wavelength of used primaries, according to preetham
const vec3 primaryWavelengths = vec3(680E-9, 550E-9, 450E-9);
// mie stuff
// K coefficient for the primaries
const vec3 K = vec3(0.686, 0.678, 0.666);
const float v = 4.0;
// optical length at zenith for molecules
const float rayleighZenithLength = 8.4E3;
const float mieZenithLength = 1.25E3;
const vec3 up = vec3(0.0, 0.0, 1.0);
const float sunIntensity = 1000.0;
float sunAngularDiameterCos = cos(sunSize*pi/180.0);
// earth shadow hack
const float cutoffAngle = pi/1.95;
const float steepness = 1.5;

float RayleighPhase(float cosViewSunAngle){
	return (3.0 / (16.0*pi)) * (1.0 + pow(cosViewSunAngle, 2.0));
}

vec3 totalMie(vec3 primaryWavelengths, vec3 K, float T){
	float c = (0.2 * T ) * 10E-18;
	return 0.434 * c * pi * pow((2.0 * pi) / primaryWavelengths, vec3(v - 2.0)) * K;
}

float hgPhase(float cosViewSunAngle, float g){
	return (1.0 / (4.0*pi)) * ((1.0 - pow(g, 2.0)) / pow(1.0 - 2.0*g*cosViewSunAngle + pow(g, 2.0), 1.5));
}

float SunIntensity(float zenithAngleCos){
	return sunIntensity * max(0.0, 1.0 - exp(-((cutoffAngle - acos(zenithAngleCos))/steepness)));
}

vec3 fromSpherical(vec2 p){
	return vec3(
		cos(p.x)*sin(p.y),
		sin(p.x)*sin(p.y),
		cos(p.y));
}
vec3 sunDirection = normalize(fromSpherical((SunPos-vec2(0.0,0.5))*vec2(6.28,3.14)));
	
vec3 sun(vec3 viewDir){
	// Cos Angles
	float cosViewSunAngle = dot(viewDir, sunDirection);
	float cosSunUpAngle = dot(sunDirection, up);
	float cosUpViewAngle = dot(up, viewDir);
	float sunE = SunIntensity(cosSunUpAngle);  // Get sun intensity based on how high in the sky it is
	// extinction (asorbtion + out scattering)
	// rayleigh coeficients
	vec3 rayleighAtX = vec3(5.176821E-6, 1.2785348E-5, 2.8530756E-5);
	// mie coefficients
	vec3 mieAtX = totalMie(primaryWavelengths, K, turbidity) * mieCoefficient;
	// optical length
	// cutoff angle at 90 to avoid singularity in next formula.
	float zenithAngle = max(0.0, cosUpViewAngle);
	float rayleighOpticalLength = rayleighZenithLength / zenithAngle;
	float mieOpticalLength = mieZenithLength / zenithAngle;
	// combined extinction factor
	vec3 Fex = exp(-(rayleighAtX * rayleighOpticalLength + mieAtX * mieOpticalLength));
	// in scattering
	vec3 rayleighXtoEye = rayleighAtX * RayleighPhase(cosViewSunAngle);
	vec3 mieXtoEye = mieAtX *  hgPhase(cosViewSunAngle, mieDirectionalG);
	vec3 totalLightAtX = rayleighAtX + mieAtX;
	vec3 lightFromXtoEye = rayleighXtoEye + mieXtoEye;
	vec3 somethingElse = sunE * (lightFromXtoEye / totalLightAtX);
	vec3 sky = somethingElse * (1.0 - Fex);
	sky *= mix(vec3(1.0),pow(somethingElse * Fex,vec3(0.5)),clamp(pow(1.0-dot(up, sunDirection),5.0),0.0,1.0));
	// composition + solar disc
	//float sundisk = smoothstep(sunAngularDiameterCos,sunAngularDiameterCos+0.00002,cosViewSunAngle);
	//float sundisk = sunAngularDiameterCos < cosViewSunAngle ? 1.0 : 0.0;
	//	smoothstep(sunAngularDiameterCos,sunAngularDiameterCos+0.00002,cosViewSunAngle);
	vec3 sun = (sunE * 19000.0 * Fex);//*sundisk;
	return 0.01*sun;
}

vec3 sky(vec3 viewDir){
	// Cos Angles
	float cosViewSunAngle = dot(viewDir, sunDirection);
	float cosSunUpAngle = dot(sunDirection, up);
	float cosUpViewAngle = dot(up, viewDir);
	float sunE = SunIntensity(cosSunUpAngle);  // Get sun intensity based on how high in the sky it is
	// extinction (asorbtion + out scattering)
	// rayleigh coeficients
	vec3 rayleighAtX = vec3(5.176821E-6, 1.2785348E-5, 2.8530756E-5);
	// mie coefficients
	vec3 mieAtX = totalMie(primaryWavelengths, K, turbidity) * mieCoefficient;
	// optical length
	// cutoff angle at 90 to avoid singularity in next formula.
	float zenithAngle = max(0.0, cosUpViewAngle);
	float rayleighOpticalLength = rayleighZenithLength / zenithAngle;
	float mieOpticalLength = mieZenithLength / zenithAngle;
	// combined extinction factor
	vec3 Fex = exp(-(rayleighAtX * rayleighOpticalLength + mieAtX * mieOpticalLength));
	// in scattering
	vec3 rayleighXtoEye = rayleighAtX * RayleighPhase(cosViewSunAngle);
	vec3 mieXtoEye = mieAtX *  hgPhase(cosViewSunAngle, mieDirectionalG);
	vec3 totalLightAtX = rayleighAtX + mieAtX;
	vec3 lightFromXtoEye = rayleighXtoEye + mieXtoEye;
	vec3 somethingElse = sunE * (lightFromXtoEye / totalLightAtX);
	vec3 sky = somethingElse * (1.0 - Fex);
	sky *= mix(vec3(1.0),pow(somethingElse * Fex,vec3(0.5)),clamp(pow(1.0-dot(up, sunDirection),5.0),0.0,1.0));
	// composition + solar disc
	float sundisk = smoothstep(sunAngularDiameterCos,sunAngularDiameterCos+0.00002,cosViewSunAngle);
	if(Sunset>0.0)sundisk+=length(0.00001*Sunset);
	vec3 sun = (sunE * 19000.0 * Fex)*sundisk;
	return SkyFactor*0.01*(sun+sky);
}

vec3 sunsky(vec3 viewDir){
	// Cos Angles
	float cosViewSunAngle = dot(viewDir, sunDirection);
	float cosSunUpAngle = dot(sunDirection, up);
	float cosUpViewAngle = dot(up, viewDir);
	if (sunAngularDiameterCos == 1.0){return vec3(1.0,0.0,0.0);}
	float sunE = SunIntensity(cosSunUpAngle);  // Get sun intensity based on how high in the sky it is
	// extinction (asorbtion + out scattering)
	// rayleigh coeficients
	vec3 rayleighAtX = vec3(5.176821E-6, 1.2785348E-5, 2.8530756E-5);
	// mie coefficients
	vec3 mieAtX = totalMie(primaryWavelengths, K, turbidity) * mieCoefficient;
	// optical length
	// cutoff angle at 90 to avoid singularity in next formula.
	float zenithAngle = max(0.0, cosUpViewAngle);
	float rayleighOpticalLength = rayleighZenithLength / zenithAngle;
	float mieOpticalLength = mieZenithLength / zenithAngle;
	// combined extinction factor
	vec3 Fex = exp(-(rayleighAtX * rayleighOpticalLength + mieAtX * mieOpticalLength));
	// in scattering
	vec3 rayleighXtoEye = rayleighAtX * RayleighPhase(cosViewSunAngle);
	vec3 mieXtoEye = mieAtX *  hgPhase(cosViewSunAngle, mieDirectionalG);
	vec3 totalLightAtX = rayleighAtX + mieAtX;
	vec3 lightFromXtoEye = rayleighXtoEye + mieXtoEye;
	vec3 somethingElse = sunE * (lightFromXtoEye / totalLightAtX);
	vec3 sky = somethingElse * (1.0 - Fex);
	sky *= mix(vec3(1.0),pow(somethingElse * Fex,vec3(0.5)),clamp(pow(1.0-dot(up, sunDirection),5.0),0.0,1.0));
	// composition + solar disc
	float sundisk = smoothstep(sunAngularDiameterCos,sunAngularDiameterCos+0.3,cosViewSunAngle);
	if(Sunset>0.0)sundisk+=length(0.00001*Sunset);
	vec3 sun = (sunE * 19000.0 * Fex)*sundisk;
	//return 0.01*(sun+SkyFactor*sky);
	return 0.01*(sun+sky);
}


float DE(vec3 pos) ; // Must be implemented in other file

#ifdef providesNormal
vec3 normal(vec3 pos, float normalDistance);
#else
vec3 normal(vec3 pos, float normalDistance) {
    normalDistance = max(normalDistance*0.5, 1.0e-7);
    vec3 e = vec3(0.0,normalDistance,0.0);
    vec3 n = vec3(DE(pos+e.yxx)-DE(pos-e.yxx),
                  DE(pos+e.xyx)-DE(pos-e.xyx),
                  DE(pos+e.xxy)-DE(pos-e.xxy));			  
    n = normalize(n);
    return n;
}
#endif

#ifdef providesColor
vec3 baseColor(vec3 point, vec3 normal);
#endif

bool floorHit = false;
float floorDist = 0.0;
vec3 floorNormal = normalize(FloorNormal);

float DEF(vec3 p) {
	float d = DE(p);
	if (EnableFloor) {
		floorDist = abs(dot(floorNormal,p)-FloorHeight);
		if (d<floorDist) {

			return d;
		}  else return floorDist;
	} else {

		return d;
	}
}
/*
bool trace(vec3 from, vec3 dir, inout vec3 hit, inout vec3 hitNormal) {
    vec3 direction = normalize(dir);
    float eps = minDist;
    float dist = 1000.0;
    float totalDist = 0.0;
    for (int steps=0; steps<RaySteps && dist > eps && totalDist<MaxDepth; steps++) {
	//for (int steps=0; steps<MaxRaySteps && dist > eps; steps++) {
        hit = from + totalDist * direction;
        dist = DE(hit) * FudgeFactor;
        totalDist += dist;
    }
    if (dist < eps) {
        hit = from + (totalDist-eps) * direction;
        hitNormal = normal(hit, eps);
        return true;
    }
    return false;
}
*/

bool trace(vec3 from, vec3 dir, inout vec3 hit, inout vec3 hitNormal) {
	vec3 direction = normalize(dir);
	float eps = minDist;
	float dist = 1000.0;
	
	floorHit = false;
	floorDist = 0.0;
	
	float totalDist = 0.0;
	 for (int steps=0; steps<RaySteps && dist > eps && totalDist<MaxDepth; steps++) {
		hit = from + totalDist * direction;
		//dist = DE(hit) * FudgeFactor;
		dist = DEF(hit);
		totalDist += dist;
	}
	if (EnableFloor && dist ==floorDist*FudgeFactor) floorHit = true;
	if (dist < eps) {
		if (floorHit) {
			hitNormal = floorNormal;
			if (dot(hitNormal,direction)>0.0) hitNormal *=-1.0;
		} else {
			//hitNormal= normal(hit-NormalBackStep*epsModified*direction, epsModified); // /*normalE*epsModified/eps*/.
			hitNormal = normal(hit, eps);
		}
		hit =  from + (totalDist-eps) * direction;
		//hitNormal = normal(hit, eps);
		return true;
	}
	return false;
}

vec3 ortho(vec3 v) {
// See : http://lolengine.net/blog/2013/09/21/picking-orthogonal-vector-combing-coconuts
    return abs(v.x) > abs(v.z) ? vec3(-v.y, v.x, 0.0) : vec3(0.0, -v.z, v.y);
}
vec2 cx=vec2(floor(mod(float(subframe)*1.0,10.)),floor(mod(float(subframe)*0.1,10.)))/10.0;

vec3 getSampleBiased(vec3 dir, float power) {
    dir = normalize(dir);
// create orthogonal vector
    vec3 o1 = normalize(ortho(dir));
    vec3 o2 = normalize(cross(dir, o1));
// Convert to spherical coords aligned to dir;
    vec2 r = rand2n();
    if (Stratify) {
        r*=0.1;
        r+= cx;
        cx = mod(cx + vec2(0.1,0.9),1.0);
    }
    r.x=r.x*2.*PI;
// This is cosine^n weighted.
// See, e.g. http://people.cs.kuleuven.be/~philip.dutre/GI/TotalCompendium.pdf
// Item 36
    r.y=pow(r.y,1.0/(power+1.0));
    float oneminus = sqrt(1.0-r.y*r.y);
    vec3 sdir = cos(r.x)*oneminus*o1+
                sin(r.x)*oneminus*o2+
                r.y*dir;
    return sdir;
}
vec3 getConeSample(vec3 dir, float extent) {
// Create orthogonal vector (fails for z,y = 0)
    dir = normalize(dir);
    vec3 o1 = normalize(ortho(dir));
    vec3 o2 = normalize(cross(dir, o1));
// Convert to spherical coords aligned to dir
    vec2 r = rand2n();
    if (Stratify) {
        r*=0.1;
        r+= cx;
    }
    r.x=r.x*2.*PI;
    r.y=1.0-r.y*extent;
    float oneminus = sqrt(1.0-r.y*r.y);
    return cos(r.x)*oneminus*o1+sin(r.x)*oneminus*o2+r.y*dir;
}
vec3 getConeSample2(vec3 dir, float extent) {
// Create orthogonal vector (fails for z,y = 0)
    dir = normalize(dir);
    vec3 o1 = normalize(ortho(dir));
    vec3 o2 = normalize(cross(dir, o1));
// Convert to spherical coords aligned to dir
    vec2 r = rand2n();
    if (Stratify) {
        r*=0.1;
        r+= cx;
    }
    r.x=r.x*2.*PI;
    r.y=1.0-r.y*extent*SoftShadows;
    float oneminus = sqrt(1.0-r.y*r.y);
    return cos(r.x)*oneminus*o1+sin(r.x)*oneminus*o2+r.y*dir;
}
vec3 cycle(vec3 c, float s) {
    return vec3(0.5)+0.5*vec3(cos(s*Cycles+c.x),cos(s*Cycles+c.y),cos(s*Cycles+c.z));
}
vec3 getColor() {
    orbitTrap.w = sqrt(orbitTrap.w);
    vec3 orbitColor;
    if (CycleColors) {
        orbitColor = cycle(X.xyz,orbitTrap.x)*X.w*orbitTrap.x +
                     cycle(Y.xyz,orbitTrap.y)*Y.w*orbitTrap.y +
                     cycle(Z.xyz,orbitTrap.z)*Z.w*orbitTrap.z +
                     cycle(R.xyz,orbitTrap.w)*R.w*orbitTrap.w;
    } else {
        orbitColor = X.xyz*X.w*orbitTrap.x +
                     Y.xyz*Y.w*orbitTrap.y +
                     Z.xyz*Z.w*orbitTrap.z +
                     R.xyz*R.w*orbitTrap.w;
    }
    vec3 color = mix(Mat_Color, 3.0*orbitColor, OrbitStrength);
    return color;
}
//for texturing
#ifdef USE_TEXTURE
//http://www.iquilezles.org/www/articles/texturerepetition/texturerepetition.htm
vec4 hash4( vec2 p ) { return fract(sin(vec4( 1.0+dot(p,vec2(37.0,17.0)), 
                                              2.0+dot(p,vec2(11.0,47.0)),
                                              3.0+dot(p,vec2(41.0,29.0)),
                                              4.0+dot(p,vec2(23.0,31.0))))*103.0); }
										  
vec4 textureNoTile1(sampler2D samp, in vec2 uv ) {
    ivec2 iuv = ivec2( floor( uv ) );
    vec2 fuv = fract( uv );
    // generate per-tile transform
    vec4 ofa = hash4( iuv + ivec2(0,0) );
    vec4 ofb = hash4( iuv + ivec2(1,0) );
    vec4 ofc = hash4( iuv + ivec2(0,1) );
    vec4 ofd = hash4( iuv + ivec2(1,1) );
    vec2 ddx = dFdx( uv );
    vec2 ddy = dFdy( uv );
    // transform per-tile uvs
    ofa.zw = sign( ofa.zw-0.5 );
    ofb.zw = sign( ofb.zw-0.5 );
    ofc.zw = sign( ofc.zw-0.5 );
    ofd.zw = sign( ofd.zw-0.5 );
    // uv's, and derivarives (for correct mipmapping)
    vec2 uva = uv*ofa.zw + ofa.xy, ddxa = ddx*ofa.zw, ddya = ddy*ofa.zw;
    vec2 uvb = uv*ofb.zw + ofb.xy, ddxb = ddx*ofb.zw, ddyb = ddy*ofb.zw;
    vec2 uvc = uv*ofc.zw + ofc.xy, ddxc = ddx*ofc.zw, ddyc = ddy*ofc.zw;
    vec2 uvd = uv*ofd.zw + ofd.xy, ddxd = ddx*ofd.zw, ddyd = ddy*ofd.zw;
    // fetch and blend
    vec2 b = smoothstep( .25,.75, fuv ); //.25,.75
    
    return mix( mix( textureGrad( samp, uva, ddxa, ddya ), 
                     textureGrad( samp, uvb, ddxb, ddyb ), b.x ), 
                mix( textureGrad( samp, uvc, ddxc, ddyc ),
                     textureGrad( samp, uvd, ddxd, ddyd ), b.x), b.y );
					 
	//return mix( mix( textureGrad( samp, uva, ddx, ddy ), 
    //                 textureGrad( samp, uvb, ddx, ddy ), b.x ), 
    //            mix( textureGrad( samp, uvc, ddx, ddy ),
    //                 textureGrad( samp, uvd, ddx, ddy ), b.x), b.y );				 
}

vec4 textureNoTile2( sampler2D samp, in vec2 uv ) {
    vec2 p = floor( uv );
    vec2 f = fract( uv );
    // derivatives (for correct mipmapping)
    vec2 ddx = dFdx( uv );
    vec2 ddy = dFdy( uv );
    // voronoi contribution
    vec4 va = vec4( 0.0 );
    float wt = 0.0;
    for( int j=-1; j<=1; j++ )
    for( int i=-1; i<=1; i++ )
    {
        vec2 g = vec2( float(i), float(j) );
        vec4 o = hash4( p + g );
        vec2 r = g - f + o.xy;
        float d = dot(r,r);
        float w = exp(-5.0*d );
        vec4 c = textureGrad( samp, uv + o.zw, ddx, ddy );
        va += w*c;
        wt += w;
    }
    // normalization
    return va/wt;
}

vec4 texcube( sampler2D sam, in vec3 p, in vec3 n, in vec2 texoff, in int texrep ) {
    vec3 m = n*n;
	vec4 x,y,z=vec4(0.);
	if(texrep==0) {
	x = texture2D( sam, p.yz + texoff);
	y = texture2D( sam, p.zx + texoff);
	z = texture2D( sam, p.xy + texoff);
	}
	if(texrep==1) {
	x = textureNoTile1( sam, p.yz + texoff);
	y = textureNoTile1( sam, p.zx + texoff);
	z = textureNoTile1( sam, p.xy + texoff);
	}
	if(texrep==2) {
	x = textureNoTile2( sam, p.yz + texoff);
	y = textureNoTile2( sam, p.zx + texoff);
	z = textureNoTile2( sam, p.xy + texoff);
	}
	
	return (x*m.x + y*m.y + z*m.z) / (m.x+m.y+m.z);
}

vec4 twotex(vec3 p, vec3 n) {
	vec4 mat=vec4(0.0);
	if (n.z > tex_normal) {
		if (tex1RepeatMode==0) {mat=texture2D(tex1,p.xy*tex1size)*tex1int;}
		if (tex1RepeatMode==1) {mat=textureNoTile1(tex1,p.xy*tex1size)*tex1int;}
		if (tex1RepeatMode==2) {mat=textureNoTile2(tex1,p.xy*tex1size)*tex1int;}
	}
	if (n.z < tex_normal) {
		if (tex2RepeatMode==0) {mat=texture2D(tex2,p.xy*tex2size)*tex2int;}
		if (tex2RepeatMode==1) {mat=textureNoTile1(tex2,p.xy*tex2size)*tex2int;}
		if (tex2RepeatMode==2) {mat=textureNoTile2(tex2,p.xy*tex2size)*tex2int;}
	}
return mat;
}

#endif

vec3 equirectangularMap(sampler2D sampler, vec3 dir) {	
	dir = normalize(dir);
	vec2 longlat = vec2(atan(dir.y,dir.x),acos(dir.z));
 	return texture2D(sampler,longlat/vec2(2.0*PI,PI)).xyz;
}
//-------------
vec3 uniformVector( in float seed) {
    float a = PI*rand( 78.233 + seed);
    float b = TWO_PI*rand( 10.873 + seed);
    return vec3( sin(b)*sin(a), cos(b)*sin(a), cos(a) );
}

float rand() {
    return rand(viewCoord*(float(subframe)+1.0));
}

float intersect( in vec3 ro, in vec3 rd )
{
	//float res = minDist;
    float res = -1.0;
	float tmax = MaxDepth;
    float t = 0.01;
    for(int i=0; i<RaySteps; i++ )
    {
        float h = DEF(ro+rd*t);
		if( h<minDist || t>tmax ) break;
        t +=  h;
    }
    if( t<tmax ) res = t;
    return res;
}



vec3 color(vec3 from, vec3 dir){
    vec3 hit = vec3(0.0);
    vec3 hitNormal = vec3(0.0);
    vec3 color = vec3(1.0);
    vec3 direct = vec3(0.0);
	vec3 bgcol = BgColor.xyz*BgColor.w;
	vec3 fgcol = Fog.xyz;//*Fog.w;
    for( int i=0; i <RayDepth; i++ ){
		
		float t = intersect(from,dir);
		float fg=1.0*Fog_Exp-exp(-pow(Fog.w,4.0)*t*t)*Fog_Exp; //simple fog
		//fgcol = mix(bgcol,fgcol,fg);
		direct =clamp(mix(direct,fgcol,fg),0.0,1.0);	
		color =clamp(mix(color,fgcol,fg),0.0,1.0);	
		
        if (trace(from,dir,hit,hitNormal)){
            if (rand() > Mat_Refl ){	
#ifdef providesColor
                color *= baseColor(hit, hitNormal);
#else
                color *= getColor();
#ifdef USE_TEXTURE

				
				//if(UseTexture) {
					if(MapType==1)color+=clamp(texcube(tex1, hit*tex1size, hitNormal, tex1offset, tex1RepeatMode).xyz,0.0,1.0);//*DeTexExposure;
					if(MapType==2)color+=clamp(twotex(hit, hitNormal).xyz,0.0,1.0);//*DeTexExposure;
					if(MapType==3)color+= clamp(equirectangularMap(tex1,hit),0.,1.);//*DeTexExposure;
				//}
				
#endif
#endif
				float dist = DEF(hit);
				if (EnableFloor && dist ==floorDist*FudgeFactor) color = FloorColor;
				
                if (!BiasedSampling) {
                    dir =getConeSample( hitNormal,1.0);
					color *= clamp(2.0*Albedo*max(0.00001,dot(dir,hitNormal)),0.,1.);
                }
                else {
                    dir =getSampleBiased( hitNormal, 1.0 );
                    color *= Albedo;
                }
				
                if (DirectLight) {
                    vec3 a=vec3(0.);
                    vec3 b=vec3(0.);
                    vec3 sunSampleDir = getConeSample2(sunDirection, 1.0-sunAngularDiameterCos);
                    float sunLight = dot(hitNormal, sunSampleDir);
                    if (sunLight>0.0 && !trace(hit+ hitNormal*3.0*minDist,sunSampleDir,a,b)) {			
                        direct += color*sun(sunSampleDir)*sunLight *1E-5;
                    }
                }
            }
            else {
				dir=reflect(dir,hitNormal)+uniformVector(rand() + 65.2*float(i))*(1.-Mat_ReflExp);
                color *= max(0.0, dot(dir, hitNormal));
				 if (DirectLight) {
                    vec3 a=vec3(0.);
                    vec3 b=vec3(0.);
                    vec3 sunSampleDir = getConeSample2(sunDirection, 1.0-sunAngularDiameterCos);
                    float sunLight = dot(hitNormal, sunSampleDir);
                    if (sunLight>0.0 && !trace(hit+ hitNormal*3.0*minDist,sunSampleDir,a,b)) {
                        direct += color*sun(sunSampleDir)*sunLight *1E-5;
                    }
                }
            }
// Choose new starting point for ray

		from = hit + hitNormal*minDist*8.0;	
		
        } else {
			//vec3 bgcol = BgColor.xyz*BgColor.w;
			if (GradientBg.w>0.0) {
				skyrot = rotationMatrixXYZ(vec3(GradientLinearRot.x,0.0,0.0))*rotationMatrixXYZ(vec3(0.0,GradientLinearRot.y,0.0))*rotationMatrixXYZ(vec3(0.0,0.0,GradientLinearRot.z));
				vec3 d = dir*skyrot; 
				if(GradientVignet) bgcol = mix(bgcol, GradientBg.xyz, GradientBg.w*length(d.xy));
				if(GradientLinear) bgcol = mix(bgcol, GradientBg.xyz, GradientBg.w*length(d.y + GradientOffset));
			}
			//if(Fog.w>0.0)bgcol =Fog.xyz;//mix(direct,fgcol,fg);
			if(i<2) direct+=clamp(color*bgcol,0.0,1.0);			
            if(EnableSky) {
				//skyrot = rotationMatrixXYZ(vec3(SkyRot.x,0.0,0.0))*rotationMatrixXYZ(vec3(0.0,SkyRot.y,0.0))*rotationMatrixXYZ(vec3(0.0,0.0,SkyRot.z));
				//vec3 d = dir*skyrot; 
				return direct + clamp(color * (i>0 ? sky(dir) : sunsky(dir)),.0,1.0);
			}
        }
		
    }
    //return clamp(direct,0.,1.);
	return direct;
}

/*
vec3 color(vec3 from, vec3 dir){
    vec3 hit = vec3(0.0);
    vec3 hitNormal = vec3(0.0);
    vec3 color = vec3(1.0);
    vec3 direct = vec3(0.0);
	skyrot = rotationMatrixXYZ(vec3(SkyRot.x,0.0,0.0))*rotationMatrixXYZ(vec3(0.0,SkyRot.y,0.0))*rotationMatrixXYZ(vec3(0.0,0.0,SkyRot.z));
    for( int i=0; i <RayDepth; i++ ){
        if (trace(from,dir,hit,hitNormal)){
// We hit something
            if (rand() > Mat_Refl ){
#ifdef providesColor
                color *= baseColor(hit, hitNormal);
#else
                color *= getColor();
#endif
//color *= (1.0-Reflectivity);
                if (!BiasedSampling) {
// Unbiased sampling:
// PDF = 1/(2*PI), BRDF = Albedo/PI
                    dir =getConeSample( hitNormal,1.0);
// modulate color with: BRDF*CosAngle/PDF
                    //color *= 2.0*Albedo*max(0.0,dot(dir,hitNormal));
					color *= clamp(2.0*Albedo*max(0.00001,dot(dir,hitNormal)),0.,1.);
                }
                else {
// Biased sampling (cosine weighted):
// PDF = CosAngle / PI, BRDF = Albedo/PI
                    dir =getSampleBiased( hitNormal, 1.0 );
// modulate color with: BRDF*CosAngle/PDF
                    color *= Albedo;
                }
// Direct
                if (DirectLight) {
                    vec3 a=vec3(0.);
                    vec3 b=vec3(0.);
                    vec3 sunSampleDir = getConeSample2(sunDirection, 1.0-sunAngularDiameterCos);
                    float sunLight = dot(hitNormal, sunSampleDir);
                    if (sunLight>0.0 && !trace(hit+ hitNormal*3.0*minDist,sunSampleDir,a,b)) {
                        direct += color*sun(sunSampleDir)*sunLight *1E-5;
                    }
                }
            }
            else {
//color *=Reflectivity;

				dir=reflect(dir,hitNormal)+uniformVector(rand() + 65.2*float(i))*(1.-Mat_ReflExp);
                color *= max(0.0, dot(dir, hitNormal));
				 if (DirectLight) {
                    vec3 a=vec3(0.);
                    vec3 b=vec3(0.);
                    vec3 sunSampleDir = getConeSample2(sunDirection, 1.0-sunAngularDiameterCos);
                    float sunLight = dot(hitNormal, sunSampleDir);
                    if (sunLight>0.0 && !trace(hit+ hitNormal*3.0*minDist,sunSampleDir,a,b)) {
                        direct += color*sun(sunSampleDir)*sunLight *1E-5;
                    }
                }
            }
// Choose new starting point for ray
            from = hit + hitNormal*minDist*8.0;
        } else {
            //if (!DirectLight) return clamp(color * sunsky(dir),0.,1.);
			//if (!DirectLight) return color * sunsky(dir);
			//float t = DE(dir);
			//float fg=1.0-exp(-pow(Fog,4.0)*t*t); //simple fog
			//direct=clamp(mix(direct,bgcol,fg),0.0,1.0);
			vec3 bgcol = BgColor.xyz*BgColor.w;
			direct+=clamp(color*bgcol,0.0,1.0);
			//skyrot = rotationMatrixXYZ(vec3(SkyRot.x,0.0,0.0))*rotationMatrixXYZ(vec3(0.0,SkyRot.y,0.0))*rotationMatrixXYZ(vec3(0.0,0.0,SkyRot.z));
			vec3 d = dir*skyrot;
            if(EnableSky) return direct + clamp(color * (i>0 ? sky(d) : sunsky(d)),.0,1.0);
			
			//return (EnableSky)? direct + clamp(color * (i>0 ? sky(dir) : sunsky(dir)),.0,1.0):direct+=clamp(color*bgcol,0.0,1.0);
        }
    }
    //return clamp(direct,0.,1.);
	
			
	return direct;
}
*/